package com.ether;

import gov.noaa.pmel.sgt.JPane;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import javax.swing.*;
import java.awt.image.BufferedImage;
import java.util.Locale;

/**
 * @author vmipsl
 * @date 05 july 2011
 */
public interface EtherPlotService
        extends Service
{
    @NotNull
    public BufferedImage createMainPane( @NotNull final MegapoliPlot megapoliPlot, @Nullable final Locale locale );

    @NotNull
    public JPane createTopPane( @Nullable final MegapoliPlot megapoliPlot );

    @NotNull
    public JPane createBottomPane( @Nullable final Integer dataNumber, @Nullable final Locale locale );

    @NotNull
    public BufferedImage createErrorPane( @NotNull final String mainError, @Nullable final String errorText, @Nullable final Locale locale );

    @NotNull
    public JPane createEmptyCenterPane( @Nullable final Locale locale );

    @NotNull
    public BufferedImage createCenterPane( @NotNull final MegapoliPlot megapoliPlot, @NotNull final Integer maxWidth, @NotNull final Integer maxHeight, @Nullable final Locale locale );

    @NotNull
    public JPane createTimeSeriePlot( @NotNull final MegapoliPlot megapoliPlot );

    @NotNull
    public JPane create2DPlot( @NotNull final MegapoliPlot megapoliPlot );

    @NotNull
    public JPanel createControlPanel();
}
